#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <time.h>
#include <errno.h>
#include "os9lib.h"

#undef SIGALRM
#define SIGALRM 14

static int alarmid = 0;
static int alarmfire = 0;


/*
 * g e t _ t i m e
 */
static int get_time()
{
  int   time, date, tick;
  short day;

  _sysdate(3, &time, &date, &day, &tick);         /* get date and ticks */

  date -= 10000;
  return(date*(24*3600) + time);
}

  
/*
 * a l a r m
 *
 * Set/reset an alarm
 */
int alarm(time)
  register int time;
{
  register int remain;
  
  if (alarmid != 0) {
    alm_delete(alarmid);   /* delete alarm */
    alarmid = 0;
    remain   = alarmfire - get_time();
  }
  else
    remain = 0;
    
  if (time == 0)            /* only delete alarm */
    return(remain < 0 ? 0 : remain);

  alarmfire = get_time() + time;

  if (!(time & 0x80000000)) {
    time <<= 8;             /* time is specified in seconds, convert to 1/256th secs */
    time |=  0x80000000;    /* set flag for 1/256th seconds */
  }
  
  if ((alarmid = alm_set(SIGALRM, time)) == -1) {      /* set alarm */
    alarmid = 0;
    return(-1);
  }

  return(remain);
}


/*
 * r a l a r m
 *
 * Set/reset repeating alarm
 */
int ralarm(time)
  register int time;
{
  if (alarmid != 0) {
    alm_delete(alarmid);   /* delete alarm */
    alarmid = 0;
  }

  if (time == 0)            /* only delete alarm */
    return(0);

  if (!(time & 0x80000000)) {
    time <<= 8;             /* time is specified in seconds, convert to 1/256th secs */
    time |= 0x80000000;     /* set flag for 1/256th seconds */
  }
  
  if ((alarmid = alm_cycle(SIGALRM, time)) == -1) {
    alarmid = 0;
    return(-1);
  }

  return(0);
}
