/* fcntl.h Header angepasst an OS-9 */

#ifndef _FCNTL_
#define _FCNTL

#ifndef S_IREAD
#include <sys/stat.h>
#endif

#define  UPDATE_   UPDAT_

#define  F_DUPFD   0	     	/* Dupliziere fildes */
#define  F_GETFD   1	    	/* Get fildes flags */

#define  F_SETFD   2         	/* Set fildes flags */
#define  F_GETFL   3         	/* Get file flags   */
#define  F_SETFL   4         	/* Set file flags   */
#define  F_SETOWN  6         	/* Set Owner	 */

#define O_RDONLY  S_IREAD
#define O_WRONLY  S_IWRITE
#define O_RDWR    S_IREAD|S_IWRITE
#ifdef S_IAPPEND
#define O_APPEND  S_IAPPEND		/* append to file */
#else
#define O_APPEND  0x10
#endif
#define O_TRUNC   0x0200		/* truncate file to size 0 */
#define O_CREAT   0x0400		/* create file on open */
#define O_EXCL    0x0800		/* do not replace existing file */

#define	FNDELAY	  0x1000		/* non-blocking I/O (4.2 style) */
#define	FAPPEND   O_APPEND		/* append on each write */
#define	FASYNC	  0x2000		/* signal pgrp when data ready */
#define	FCREAT	  O_CREAT		/* create if nonexistent */
#define	FTRUNC	  O_TRUNC		/* truncate to zero length */
#define	FEXCL	  O_EXCL		/* error if already created */
#define	FNBIO	  0x4000		/* non-blocking I/O (S5-style) */
#define	FSYNC	  0x8000		/* synchronous writes */

#ifndef _UCC
#ifndef _IOFBF
#define _IOFBF		0
#define _IOLBF		1
#define _IONBF		2
#endif
#endif

#endif
