#include <stdio.h>
#include <procid.h>

#ifndef ERROR
#define ERROR (-1)
#endif

static int killpg2( int pid, int signo)
{
	static 		int nthincarn = 0;
	static procid	procid;
  	int		sid,cid;

	if ( _get_process_desc(pid,sizeof(procid),&procid) == ERROR )
		return ERROR;

	if ( nthincarn++ )
		sid = procid._sid;
	else
		sid = 0;

	cid = procid._cid;

	/* signal siblings */

	if ( sid > 0 )
		if ( killpg(sid,signo) )
			return ERROR;

	/* signal descendants */

	if ( cid > 0 )
		if( killpg(cid,signo) )
			return ERROR;

  	if ( kill(pid,signo) == ERROR )
		return ERROR;

	--nthincarn;

    return 0;
}

int killpg( int pid, int signo )
{
	static int 	nthincarn = 0;
	static procid	procid;
	int		cid;

	if (_get_process_desc(pid,sizeof(procid),&procid) == ERROR )
		return ERROR;
		
	if ( cid = procid._cid )
		if ( killpg2(cid,signo) )
			return ERROR;

	if ( kill(pid,signo) == ERROR )
		return ERROR;

   return 0;

}
