#ifndef _UNISTD_H
#define _UNISTD_H

#ifndef _STDIO_H
#include <stdio.h>
#endif

/* Start a new process (forking) */
int       execl(char*, char *, ...);
int       execle(char*, char *, ...);
int       execlp(char*, char*, ...);
int       execv(char*,  char**);
int       execve(char*, char**, char**);
int       execvp(char*,  char**);

/* Replace current process with new process (chaining) */
int       execl_chain(char*, char *, ...);
int       execle_chain(char*, char *, ...);
int       execv_chain(char*,  char**);
int       execve_chain(char*, char**, char**);
int       execvp_chain(char*,  char**);

int       fchown(int fd, int uid, int gid);

#ifdef _STAT_H_
int       fstat( int, struct stat *);
int       stat(char *, struct stat *);
#endif
int       getdtablesize();

int       link(char *, char *);

int       fcntl(int fildes, int cmd, int arg);

char      *getpass(char *prompt);

FILE       *popen(char *name, char *mode);
FILE       *xpopen(char *name, char *mode);

char       *cuserid( void );
char       *chome( void );

#endif
